#
# spec file for package libcacard
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           libcacard
Url:            http://www.qemu.org/
Summary:        Universal CPU emulator
License:        BSD-3-Clause and GPL-2.0 and GPL-2.0+ and LGPL-2.1+ and MIT
Group:          System/Emulators/PC
Version:        2.3.0
Release:        0
Source:         http://wiki.qemu.org/download/qemu-2.3.0.tar.bz2
# This patch queue is auto-generated from https://github.com/openSUSE/qemu
Patch0001:      0001-XXX-dont-dump-core-on-sigabort.patch
Patch0002:      0002-XXX-work-around-SA_RESTART-race-wit.patch
Patch0003:      0003-qemu-0.9.0.cvs-binfmt.patch
Patch0004:      0004-qemu-cvs-alsa_bitfield.patch
Patch0005:      0005-qemu-cvs-alsa_ioctl.patch
Patch0006:      0006-qemu-cvs-alsa_mmap.patch
Patch0007:      0007-qemu-cvs-gettimeofday.patch
Patch0008:      0008-qemu-cvs-ioctl_debug.patch
Patch0009:      0009-qemu-cvs-ioctl_nodirection.patch
Patch0010:      0010-block-vmdk-Support-creation-of-SCSI.patch
Patch0011:      0011-linux-user-add-binfmt-wrapper-for-a.patch
Patch0012:      0012-PPC-KVM-Disable-mmu-notifier-check.patch
Patch0013:      0013-linux-user-fix-segfault-deadlock.patch
Patch0014:      0014-linux-user-binfmt-support-host-bina.patch
Patch0015:      0015-linux-user-Ignore-broken-loop-ioctl.patch
Patch0016:      0016-linux-user-lock-tcg.patch
Patch0017:      0017-linux-user-Run-multi-threaded-code-.patch
Patch0018:      0018-linux-user-lock-tb-flushing-too.patch
Patch0019:      0019-linux-user-Fake-proc-cpuinfo.patch
Patch0020:      0020-linux-user-implement-FS_IOC_GETFLAG.patch
Patch0021:      0021-linux-user-implement-FS_IOC_SETFLAG.patch
Patch0022:      0022-linux-user-XXX-disable-fiemap.patch
Patch0023:      0023-slirp-nooutgoing.patch
Patch0024:      0024-vnc-password-file-and-incoming-conn.patch
Patch0025:      0025-linux-user-add-more-blk-ioctls.patch
Patch0026:      0026-linux-user-use-target_ulong.patch
Patch0027:      0027-block-Add-support-for-DictZip-enabl.patch
Patch0028:      0028-block-Add-tar-container-format.patch
Patch0029:      0029-Legacy-Patch-kvm-qemu-preXX-dictzip.patch
Patch0030:      0030-console-add-question-mark-escape-op.patch
Patch0031:      0031-Make-char-muxer-more-robust-wrt-sma.patch
Patch0032:      0032-linux-user-lseek-explicitly-cast-no.patch
Patch0033:      0033-virtfs-proxy-helper-Provide-__u64-f.patch
Patch0034:      0034-configure-Enable-PIE-for-ppc-and-pp.patch
Patch0035:      0035-qtest-Increase-socket-timeout.patch
Patch0036:      0036-AIO-Reduce-number-of-threads-for-32.patch
Patch0037:      0037-linux-user-Allocate-thunk-size-dyna.patch
Patch0038:      0038-Revert-Revert-seccomp-tests-that-al.patch
Patch0039:      0039-s390x-Fix-stoc-direction.patch
Patch0040:      0040-s390x-Add-interlocked-access-facili.patch
# Please do not add patches manually here, run update_git.sh.
# this is to make lint happy
Source300:      qemu-rpmlintrc
Source400:      update_git.sh
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  e2fsprogs-devel
BuildRequires:  fdupes
BuildRequires:  gcc-c++
BuildRequires:  glib2-devel
BuildRequires:  libattr-devel
BuildRequires:  libtool
BuildRequires:  mozilla-nss-devel
BuildRequires:  ncurses-devel
BuildRequires:  python
BuildRequires:  zlib-devel

%description
QEMU is an extremely well-performing CPU emulator that allows you to
choose between simulating an entire system and running userspace
binaries for different architectures under your native operating
system. It currently emulates x86, ARM, PowerPC and SPARC CPUs as well
as PC and PowerMac systems.

This sub-package contains statically linked binaries for running linux-user
emulations. This can be used together with the OBS build script to
run cross-architecture builds.

%package -n libcacard0
Summary:        Common Access Card (CAC) emulation
Group:          System/Emulators/PC

%description -n libcacard0
This emulator is designed to provide emulation of actual smart cards to a
virtual card reader running in a guest virtual machine. The emulated smart
cards can be representations of real smart cards, where the necessary functions
such as signing, card removal/insertion, etc. are mapped to real, physical
cards which are shared with the client machine the emulator is running on, or
the cards could be pure software constructs.

%package -n libcacard-devel
Summary:        Common Access Card (CAC) emulation -- Development files
Group:          Development/Languages/C and C++
Requires:       glib2-devel
Requires:       libcacard0 = %version
Requires:       mozilla-nspr
Requires:       mozilla-nss

%description -n libcacard-devel
This emulator is designed to provide emulation of actual smart cards to a
virtual card reader running in a guest virtual machine. The emulated smart
cards can be representations of real smart cards, where the necessary functions
such as signing, card removal/insertion, etc. are mapped to real, physical
cards which are shared with the client machine the emulator is running on, or
the cards could be pure software constructs.

This sub-package contains development files for the Smartcard library.

%prep
%setup -q -n qemu-2.3.0
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1

%build
./configure --prefix=%_prefix --sysconfdir=%_sysconfdir \
	--libdir=%_libdir \
	--libexecdir=%_libexecdir \
	--disable-strip \
	--enable-smartcard-nss \
	--extra-cflags="$QEMU_OPT_FLAGS"
make %{?_smp_mflags} V=1 libcacard.la

%install
make install-libcacard DESTDIR=$RPM_BUILD_ROOT
rm -f $RPM_BUILD_ROOT/%_libdir/libcacard.a
rm -f $RPM_BUILD_ROOT/%_libdir/libcacard.la

%post   -n libcacard0 -p /sbin/ldconfig

%postun -n libcacard0 -p /sbin/ldconfig

%files -n libcacard0
%defattr(-, root, root)
%_libdir/libcacard.so.0*

%files -n libcacard-devel
%defattr(-, root, root)
%dir %_includedir/cacard
%_includedir/cacard/*.h
%_libdir/libcacard.so
%_libdir/pkgconfig/libcacard.pc

%changelog
